// Generated by CoffeeScript 1.6.3
(function() {
  var Access, Base, Block, Call, Class, Code, ES5For, For, LEVEL_TOP, Literal, Param, Return, Transformer, UseES5MethodsInsteadOfForLoops, Value, any, apply, toSAST, underscore, _ref, _ref1,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  underscore = require('underscore');

  _ref = require('./nodes'), Base = _ref.Base, Return = _ref.Return, Call = _ref.Call, Code = _ref.Code, Param = _ref.Param, Class = _ref.Class, Block = _ref.Block, For = _ref.For, Value = _ref.Value, Access = _ref.Access, Literal = _ref.Literal, any = _ref.any, LEVEL_TOP = _ref.LEVEL_TOP;

  Transformer = (function() {
    function Transformer() {
      this.runOn = __bind(this.runOn, this);
    }

    Transformer.prototype.on = function(node) {
      return true;
    };

    Transformer.prototype.stopOn = function(node) {
      return false;
    };

    Transformer.prototype.map = function(node) {};

    Transformer.prototype.transform = function(node) {
      this.map(node);
      return node;
    };

    Transformer.prototype.runOn = function(node) {
      var attr, _i, _len, _ref1,
        _this = this;
      if (node instanceof Base) {
        if (this.stopOn && this.stopOn(node)) {
          return node;
        }
        _ref1 = node.children;
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          attr = _ref1[_i];
          if (node[attr]) {
            node[attr] = this.runOn(node[attr]);
          }
        }
        if (!this.on || this.on(node)) {
          return this.transform(node);
        }
        return node;
      } else if (node instanceof Array) {
        return node.map(function(e) {
          return _this.runOn(e);
        });
      } else {
        throw "internal compiler error";
      }
    };

    return Transformer;

  })();

  apply = function(transformers) {
    return function(node) {
      var transformer, _i, _len;
      for (_i = 0, _len = transformers.length; _i < _len; _i++) {
        transformer = transformers[_i];
        node = new transformer().runOn(node);
      }
      return node;
    };
  };

  UseES5MethodsInsteadOfForLoops = (function(_super) {
    __extends(UseES5MethodsInsteadOfForLoops, _super);

    function UseES5MethodsInsteadOfForLoops() {
      this.transform = __bind(this.transform, this);
      this.on = __bind(this.on, this);
      _ref1 = UseES5MethodsInsteadOfForLoops.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    UseES5MethodsInsteadOfForLoops.prototype.on = function(f) {
      return f instanceof For && !(f.index || f.object || f.step || f.pattern || f.jumps() || f.contains(function(n) {
        return n.match([
          new Literal("continue"), new Literal("break"), function() {
            return true;
          }, any, function() {
            return false;
          }
        ]);
      }));
    };

    UseES5MethodsInsteadOfForLoops.prototype.transform = function(f) {
      var comprehension, mkLam, mkMCall;
      mkMCall = function(obj, meth, args) {
        return new Call(new Value(obj, [new Access(new Literal(meth))]), args);
      };
      mkLam = function(exprs) {
        var lam;
        lam = new Code([new Param(f.name)], Block.wrap([exprs]), 'boundfunc');
        lam.undeclaredScope = lam.sharedScope = true;
        return lam;
      };
      if (!f.guard) {
        comprehension = f.source;
      } else {
        comprehension = mkMCall(f.source, "filter", [mkLam(Block.wrap([new Return(f.guard)]))]);
      }
      return new ES5For(comprehension, f.name, f.body);
    };

    return UseES5MethodsInsteadOfForLoops;

  })(Transformer);

  ES5For = (function(_super) {
    __extends(ES5For, _super);

    function ES5For(loopSource, name, body) {
      this.loopSource = loopSource;
      this.forBody = new Code([new Param(name)], Block.wrap([body]), 'boundfunc');
      this.forBody.undeclaredScope = this.forBody.sharedScope = true;
      ES5For.__super__.constructor.call(this, new Value(loopSource, [new Access(new Literal("map"))]), [this.forBody]);
    }

    ES5For.prototype.compileNode = function(o) {
      if (o.level !== LEVEL_TOP) {
        return ES5For.__super__.compileNode.apply(this, arguments);
      }
      return new Call(new Value(this.loopSource, [new Access(new Literal("forEach"))]), [this.forBody]).compileNode(o);
    };

    return ES5For;

  })(Call);

  exports.toSAST = toSAST = apply([UseES5MethodsInsteadOfForLoops]);

}).call(this);

/*
//@ sourceMappingURL=transformer.map
*/
